osl::rating::DefenseKing8 Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
osl::rating::DefenseKing8 Class Reference

`#include <king8.h>`

Inheritance diagram for osl::rating::DefenseKing8:
[legend]
Collaboration diagram for osl::rating::DefenseKing8:
[legend]

## Public Member Functions
| DefenseKing8 (Ptype s, bool d, int dan)
bool | match (const NumEffectState &state, Move move, const RatingEnv &) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Public Member Functions
static const std::string | name (Ptype self, bool drop, int danger)
static int | count (const NumEffectState &state)
static bool | blocking (const NumEffectState &state, Square king, Square to)
static bool | matchDrop (const NumEffectState &state, Move move)
static bool | matchMove (const NumEffectState &state, Move move)

## Private Attributes
Ptype | self
bool | drop
int | danger

## Detailed Description

Definition at line 47 of file rating/feature/king8.h.

## Constructor & Destructor Documentation

osl::rating::DefenseKing8::DefenseKing8 | ( | Ptype | s,
|  | bool | d,
|  | int | dan
| ) |  |
| inline

Definition at line 54 of file rating/feature/king8.h.

## Member Function Documentation

static bool osl::rating::DefenseKing8::blocking | ( | const NumEffectState & | state,
|  | Square | king,
|  | Square | to
| ) |  |
| inlinestatic

Definition at line 77 of file rating/feature/king8.h.

References osl::alt(), osl::BISHOP, osl::move_generator::addeffect8::hasEffect(), osl::LANCE, osl::newPtypeO(), and osl::ROOK.

Referenced by matchDrop(), and matchMove().

static int osl::rating::DefenseKing8::count | ( | const NumEffectState & | state) |  |
| inlinestatic

Definition at line 58 of file rating/feature/king8.h.

References osl::alt(), and osl::eval::min().

Referenced by osl::rating::DefenseKing8Group::findMatch(), and match().

bool osl::rating::DefenseKing8::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & |
| ) |  | const
| inlinevirtual

Implements osl::rating::Feature.

Definition at line 115 of file rating/feature/king8.h.

References count(), danger, drop, matchDrop(), matchMove(), and osl::Move::ptype().

static bool osl::rating::DefenseKing8::matchDrop | ( | const NumEffectState & | state,
|  | Move | move
| ) |  |
| inlinestatic

Definition at line 92 of file rating/feature/king8.h.

References blocking(), osl::move_generator::addeffect8::hasEffect(), osl::Move::isDrop(), osl::Neighboring8::isNeighboring8(), osl::Move::ptypeO(), and osl::Move::to().

Referenced by osl::rating::DefenseKing8Group::findMatch(), and match().

static bool osl::rating::DefenseKing8::matchMove | ( | const NumEffectState & | state,
|  | Move | move
| ) |  |
| inlinestatic

Definition at line 102 of file rating/feature/king8.h.

References blocking(), osl::Move::from(), osl::move_generator::addeffect8::hasEffect(), osl::Move::isDrop(), osl::Neighboring8::isNeighboring8(), osl::KING, osl::Move::ptype(), osl::Move::ptypeO(), and osl::Move::to().

Referenced by osl::rating::DefenseKing8Group::findMatch(), and match().

const std::string osl::rating::DefenseKing8::name | ( | Ptype | self,
|  | bool | drop,
|  | int | danger
| ) |  |
| static

Definition at line 11 of file rating/feature/king8.cc.

References osl::PtypeTable::getCsaName(), and osl::Ptype_Table.

## Member Data Documentation

int osl::rating::DefenseKing8::danger
| private

Definition at line 51 of file rating/feature/king8.h.

Referenced by match().

bool osl::rating::DefenseKing8::drop
| private

Definition at line 50 of file rating/feature/king8.h.

Referenced by match().

Ptype osl::rating::DefenseKing8::self
| private

Definition at line 49 of file rating/feature/king8.h.

The documentation for this class was generated from the following files:

- rating/feature/king8.h
- rating/feature/king8.cc